Include CpuLoad_pdh.Inc

.CODE

Start:

  Invoke Main
  Invoke ExitProcess,0

Main Proc

Local pfc:PDH_FMT_COUNTERVALUE

	xor eax,eax
	mov cpl.uElapse,500
	
    Invoke InitPdhCounter
@@: Invoke PdhCollectQueryData,cpl.hQuery
;-- Read new data
    Invoke PdhGetFormattedCounterValue,cpl.hCounter,PDH_FMT_LONG,0,ADDR pfc
;-- Check for valid data
    .if pfc.CStatus == PDH_CSTATUS_VALID_DATA
        print ADDR CRLF
        print ustr$(pfc.longValue)
        print SADD("%")
    .endif
	
    invoke Sleep,250
    call crt__kbhit
    test eax, eax
    jz @B
    
    Invoke PdhRemoveCounter,cpl.hCounter
    Invoke PdhCloseQuery,cpl.hQuery    
    
    ret
Main EndP

InitPdhCounter PROC

Local pcpe:PDH_COUNTER_PATH_ELEMENTS
Local os:OSVERSIONINFO
Local dwBufferSize:DWORD
Local lpszCntPath:DWORD
	
;-- RETRIEVE THE LOCALIZED LANGUAGE STRING

;-- Retrieve the computer name
	mov dwBufferSize,MAX_COMPUTERNAME_LENGTH+1
	Invoke LocalAlloc,LPTR,dwBufferSize
	mov pcpe.szMachineName,eax
	Invoke GetComputerName,pcpe.szMachineName,ADDR dwBufferSize
	
;-- Retrieve performance object name by index: 238 ("Processor")
	mov dwBufferSize,MAX_PATH
	Invoke LocalAlloc,LPTR,dwBufferSize
	mov pcpe.szObjectName,eax
	Invoke PdhLookupPerfNameByIndex,pcpe.szMachineName,238,pcpe.szObjectName, ADDR dwBufferSize
	
;-- Retrieve performance object name by index: 6 ("% Processor Time")
	mov dwBufferSize,MAX_PATH
	Invoke LocalAlloc,LPTR,dwBufferSize
	mov pcpe.szCounterName,eax
	Invoke PdhLookupPerfNameByIndex,pcpe.szMachineName,6,pcpe.szCounterName, ADDR dwBufferSize
	
;-- Initialize other parts of PDH_COUNTER_PATH_ELEMENTS struct
	lea edx,szInstName				; "_Total" or "0"
	mov pcpe.szInstanceName,edx
	mov pcpe.szParentInstance,eax	; NULL
	mov pcpe.dwInstanceIndex,eax    ; NULL
	
;-- Create a full counter path
	mov dwBufferSize,PDH_MAX_COUNTER_PATH
	Invoke LocalAlloc,LPTR,dwBufferSize
	mov lpszCntPath,eax
	Invoke PdhMakeCounterPath,ADDR pcpe,lpszCntPath,ADDR dwBufferSize,0
	print SADD("Counter Path: ")
	print lpszCntPath
;-- Create a PDH Query
	Invoke PdhOpenQuery,0,0,ADDR cpl.hQuery
;-- Add a counter to the query for the counterPath specified.
	Invoke PdhAddCounter,cpl.hQuery,lpszCntPath,0,ADDR cpl.hCounter
	test eax,eax
	jnz _exit		; something went wrong !?
;-- Provide a starting value
	Invoke PdhCollectQueryData,cpl.hQuery

_exit:
	Invoke LocalFree,pcpe.szMachineName
	Invoke LocalFree,pcpe.szObjectName
	Invoke LocalFree,pcpe.szCounterName
	Invoke LocalFree,lpszCntPath
	ret
InitPdhCounter EndP

End Start
